<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 1/2/16
 * Time: 9:16 PM
 */

namespace IMATHUZH\Qfq\Tests\Unit\Core\Store;

 
use IMATHUZH\Qfq\Core\Store\Config;
use PHPUnit\Framework\TestCase;

/**
 * Class ConfigTest
 * @package qfq
 */
class ConfigTest extends TestCase {


    /**
     * @expectedException \UserFormException
     *
     * @throws \CodeException
     * @throws \UserFormException
     * @throws \UserReportException
     */
    public function testCheckForAttack() {

        $config = Config::setDefaults(array());

        $_GET['fake'] = '012345678901234567890123456789012345678901234567890123456789';
        Config::checkForAttack($config);
    }

    /**
     *
     * @throws \CodeException
     * @throws \UserFormException
     * @throws \UserReportException
     */
    public function testCheckForAttack2() {

        $config = Config::setDefaults(array());

        // Check for customized length (below)
        # 60
        $_GET['fake_65'] = '012345678901234567890123456789012345678901234567890123456789';
        Config::checkForAttack($config);

        $this->assertEquals(1, 1);
    }

    /**
     * @expectedException \UserFormException
     *
     * @throws \CodeException
     * @throws \UserFormException
     * @throws \UserReportException
     */
    public function testCheckForAttack3() {

        $config = Config::setDefaults(array());

        // Check for customized length (above)
        # 80
        $_GET['fake_65'] = '01234567890123456789012345678901234567890123456789012345678901234567890123456789';
        Config::checkForAttack($config);

    }

    /**
     * @expectedException \UserFormException
     *
     * @throws \CodeException
     * @throws \UserFormException
     * @throws \UserReportException
     */
    public function testCheckForAttack4() {

        $config = Config::setDefaults(array());

        $_POST['email'] = 'no@email.com';
        Config::checkForAttack($config);
    }

    /**
     * @return void
     */
    public function testGetRedirectAllMailTo() {

        $this->assertEquals('', Config::getRedirectAllMailTo(''));
        $this->assertEquals('john@doe.com', Config::getRedirectAllMailTo('john@doe.com'));
        $this->assertEquals('jane@doe.com', Config::getRedirectAllMailTo('john@doe.com,jane@doe.com'));
        $this->assertEquals('son@doe.com', Config::getRedirectAllMailTo('john@doe.com,jane@doe.com,son@doe.com'));

        # BE and FE configuration can't be tested, cause the T3 BE / FE email will only be given in an active T3 environment.
    }

    protected function setUp() {
        $_GET = array();
        $_POST = array();
    }

    protected function tearDown() {
        $_GET = array();
        $_POST = array();
    }
}
